#ifndef _IDSA_JOB_H_
#define _IDSA_JOB_H_

#include <unistd.h>

#include <sys/types.h>

#include <idsa_internal.h>

#define JOB_STATEFIN         0x00  /* end, close connection */

#define JOB_STATEWAIT        0x01  /* wait for event from client */
#define JOB_STATEWRITE       0x02  /* send result to client */

#include "types.h"

struct job{
  int j_fd;
  pid_t j_pid;
  gid_t j_gid;
  uid_t j_uid;

  int j_state; /* should only be touched in job.c */

  int j_rl; /* read buffer length */
  char j_rbuf[IDSA_M_MESSAGE];

  int j_wl; /* write buffer length */
  char j_wbuf[IDSA_M_MESSAGE];
};

#define job_isend(j)   ((j->j_state!=JOB_STATEWRITE)&&(j->j_state!=JOB_STATEWAIT))
#define job_iswrite(j) ((j->j_state==JOB_STATEWRITE)||(j->j_wl>0))
#define job_iswork(j)  ((j->j_state==JOB_STATEWAIT)&&(j->j_rl>0))

int job_accept(JOB *j, int fd);
void job_copy(JOB *t, JOB *s);
void job_drop(int fd);
int job_end(JOB *j);

int job_write(JOB *j);
int job_read(JOB *j);
int job_do(JOB *j, STATE_SET *s);

#endif
